#ifndef ENTERMODE_H
#define ENTERMODE_H

#include <QWidget>
#include <QPushButton>
#include <QGridLayout>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QLabel>
#include <QRadioButton>

#include <TC_types.h>
#include <paulcommoncrc.h>

class EnterMode : public QWidget
{
    Q_OBJECT
public:
    explicit EnterMode(QWidget *parent = 0);

    void sendEnterMode(unsigned char mode);
    void setTimeToSend( );

    QPushButton *button_enterModeStandby;
    QPushButton *button_enterModeNormal;
    QPushButton *button_enterModeBurst;
    QPushButton *button_enterModeSBM1;
    QPushButton *button_enterModeSBM2;

    QPushButton *button_reset;
    QPushButton *button_updateInfo;
    QPushButton *button_enableCalibration;
    QPushButton *button_disableCalibration;
    QPushButton *button_updateTime;

    QGridLayout *mainLayout;
    QGridLayout *overallLayout;

    QVBoxLayout *layout_updateTime;
    QVBoxLayout *layout_otherTC;

    QGroupBox *groupBox;
    QGroupBox *groupBox_updateTime;
    QGroupBox *groupBox_otherTC;

    PaulCommonCRC *paulCommonCRC;

    unsigned int lastTMTime;
    unsigned int timeToSend;
    QLabel *label_lastTMTime;

    QRadioButton *radio_minus1;
    QRadioButton *radio_plus0;
    QRadioButton *radio_plus1;
    QRadioButton *radio_plus2;
    QRadioButton *radio_now;
    QRadioButton *radio_plus4;

//    ArbitraryTime *arbitraryTime;
    
signals:
    unsigned int WriteSPWSig(char *Value, unsigned int count, char targetLogicalAddress, char userApplication);
    
public slots:
    void enterModeStandby();
    void enterModeNormal();
    void enterModeBurst();
    void enterModeSBM1();
    void enterModeSBM2();

    void sendReset();
    void sendUpdateInfo();
    void initSpareTcLfrUpdateInfo( Packet_TC_LFR_UPDATE_INFO_t *packet );
    void sendEnableCalibration();
    void sendDisableCalibration();

    void lastTMTimeHasChanged( unsigned int lastTime );
    
};

#endif // ENTERMODE_H
