#include "incomingtmparser.h"

IncomingTMParser::IncomingTMParser(QObject *parent) :
    QObject(parent)
{
    incompleteData = false;
    localDataArray.clear();
}

void IncomingTMParser::processIncomingQByteArray(QByteArray incomingQByteArray)
{
    int ccsdsSize;
    unsigned char *ccsdsData;
    TMPacketToRead *packet;
    bool keepParsing;

    keepParsing = true;

    localDataArray.append( incomingQByteArray );

    if (localDataArray.size() >= 4 )
    {
        while(keepParsing == true)
        {
            ccsdsSize = ( (unsigned char) localDataArray[3] ) * 256 * 256
                    + ( (unsigned char) localDataArray[2] ) * 256
                    + ( (unsigned char) localDataArray[1] );

            if (localDataArray.size() < (ccsdsSize+4) ) keepParsing = false;
            else
            {
                localDataArray.remove(0, 4);    // remove the 4 first bytes which are not CCSDS data

                ccsdsData = (unsigned char *) localDataArray.data();

                packet = new TMPacketToRead(ccsdsData, ccsdsSize);

                emit sendPacket( packet );

                localDataArray.remove(0, ccsdsSize);
            }

            if (localDataArray.size() >= 4 )    keepParsing = true;
            else                                keepParsing = false;
        }
    }
}

