#include "lfractions.h"

LFRActions::LFRActions(QWidget *parent) :
    QWidget(parent)
{
    mainLayout = new QGridLayout();
    enterMode = new EnterMode();
    parameterDump = new ParameterDump();

    parameterDump->actionsSetEnabled(true);

    mainLayout->addWidget(parameterDump, 0, 0, 1, 1);
    mainLayout->addWidget(enterMode, 0, 1, 1, 1);

    mainLayout->setColumnStretch(2, 1);
    mainLayout->setRowStretch(1, 1);

    this->setLayout(mainLayout);

    connect(this->enterMode, SIGNAL(WriteSPWSig(char*,uint,char,char)),
            this, SLOT(reEmitWriteSPWSig(char*,uint,char,char)));
    connect(this->parameterDump, SIGNAL(WriteSPWSig(char*,uint,char,char)),
            this, SLOT(reEmitWriteSPWSig(char*,uint,char,char)));
//    connect(this->enterMode->arbitraryTime, SIGNAL(WriteSPW(char*,uint,char,char)),
//            this, SLOT(reEmitWriteSPWSig(char*,uint,char,char)));
}

void LFRActions::reEmitWriteSPWSig(char *Value, unsigned int count, char targetLogicalAddress, char userApplication){
    emit WriteSPWSig( Value, count, targetLogicalAddress, userApplication);
}
